    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * ShipNeedle.java
    029     * ---------------
    030     * (C) Copyright 2002-2006, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: ShipNeedle.java,v 1.4.2.3 2006/08/02 10:40:57 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 27-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.needle;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.geom.Arc2D;
    051    import java.awt.geom.GeneralPath;
    052    import java.awt.geom.Point2D;
    053    import java.awt.geom.Rectangle2D;
    054    import java.io.Serializable;
    055
    056    /**
    057     * A needle in the shape of a ship, for use with the
    058     * {@link org.jfree.chart.plot.CompassPlot} class.
    059     */
    060    public class ShipNeedle extends MeterNeedle
    061                            implements Cloneable, Serializable {
    062
    063        /** For serialization. */
    064        private static final long serialVersionUID = 149554868169435612L;
    065
    066        /**
    067         * Draws the needle.
    068         *
    069         * @param g2  the graphics device.
    070         * @param plotArea  the plot area.
    071         * @param rotate  the rotation point.
    072         * @param angle  the angle.
    073         */
    074        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    075                                  Point2D rotate, double angle) {
    076
    077            GeneralPath shape = new GeneralPath();
    078            shape.append(new Arc2D.Double(-9.0, -7.0, 10, 14, 0.0, 25.5,
    079                    Arc2D.OPEN), true);
    080            shape.append(new Arc2D.Double(0.0, -7.0, 10, 14, 154.5, 25.5,
    081                    Arc2D.OPEN), true);
    082            shape.closePath();
    083            getTransform().setToTranslation(plotArea.getMinX(), plotArea.getMaxY());
    084            getTransform().scale(plotArea.getWidth(), plotArea.getHeight() / 3);
    085            shape.transform(getTransform());
    086
    087            if ((rotate != null) && (angle != 0)) {
    088                /// we have rotation
    089                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    090                shape.transform(getTransform());
    091            }
    092
    093            defaultDisplay(g2, shape);
    094        }
    095
    096        /**
    097         * Tests another object for equality with this object.
    098         *
    099         * @param object  the object to test.
    100         *
    101         * @return A boolean.
    102         */
    103        public boolean equals(Object object) {
    104            if (object == null) {
    105                return false;
    106            }
    107            if (object == this) {
    108                return true;
    109            }
    110            if (super.equals(object) && object instanceof ShipNeedle) {
    111                return true;
    112            }
    113            return false;
    114        }
    115
    116        /**
    117         * Returns a clone of this needle.
    118         *
    119         * @return A clone.
    120         *
    121         * @throws CloneNotSupportedException if the <code>ShipNeedle</code>
    122         *     cannot be cloned (in theory, this should not happen).
    123         */
    124        public Object clone() throws CloneNotSupportedException {
    125            return super.clone();
    126        }
    127
    128    }
    129